Index: typo3/sysext/install/mod/class.tx_install.php
===================================================================
--- typo3/sysext/install/mod/class.tx_install.php	(revision 7289)
+++ typo3/sysext/install/mod/class.tx_install.php	(working copy)
@@ -2100,128 +3243,565 @@
 	/**
 	 * Prints form for updating localconf.php or updates localconf.php depending on $cmd
 	 *
-	 * @param	string		$cmd	If "get_form" it outputs the form. Default is to write "localconf.php" based on input in ->INSTALL[localconf.php] array and flag ->setLocalconf
-	 * @return	[type]		...
+	 * @param string $cmd If "get_form" it outputs the form. Default is to write "localconf.php" based on input in ->INSTALL[localconf.php] array and flag ->setLocalconf
+	 * @return string Form HTML
 	 */
-	function setupGeneral($cmd='')	{
-		switch($cmd)	{
+	function setupGeneral($cmd='') {
+		switch($cmd) {
 			case 'get_form':
-					// Database:
-				$out='
-				<form name="setupGeneral" action="'.$this->action.'" method="post">
-				<table border="0" cellpadding="0" cellspacing="0">';
+					// Get the template file
+				$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'SetupGeneral.html');
+					// Get the template part from the file
+				$form = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+					// Get the subpart for all modes
+				$allModesSubpart = $this->contentObject->getSubpart($form, '###ALLMODES###');
+					// Define the markers content
+				$formMarkers['actionUrl'] = $this->action;
 
-				$out.=$this->wrapInCells('Username:', '<input type="text" name="TYPO3_INSTALL[localconf.php][typo_db_username]" value="'.htmlspecialchars(TYPO3_db_username?TYPO3_db_username:($this->config_array['sql.safe_mode_user']?$this->config_array['sql.safe_mode_user']:"")).'">'.($this->config_array['sql.safe_mode_user']?"<br />sql.safe_mode_user: <strong>".$this->config_array['sql.safe_mode_user']."</strong>":""));
-				$out.=$this->wrapInCells('Password:', '<input type="password" name="TYPO3_INSTALL[localconf.php][typo_db_password]" value="'.htmlspecialchars(TYPO3_db_password).'">');
-				$out.=$this->wrapInCells('Host:', '<input type="text" name="TYPO3_INSTALL[localconf.php][typo_db_host]" value="'.htmlspecialchars(TYPO3_db_host).'">');
-				if ($this->config_array['mysqlConnect'])	{
+					// Username
+				if (TYPO3_db_username) {
+					$username = TYPO3_db_username;
+				} elseif ($this->config_array['sql.safe_mode_user']) {
+					$username = $this->config_array['sql.safe_mode_user'];
+						// Get the subpart for the sql safe mode user
+					$sqlSafeModeUserSubpart = $this->contentObject->getSubpart($allModesSubpart, '###SQLSAFEMODEUSERSUBPART###');
+						// Define the markers content
+					$sqlSafeModeUserMarkers = array(
+						'labelSqlSafeModeUser' => 'sql.safe_mode_user:',
+						'sqlSafeModeUser' => $this->config_array['sql.safe_mode_user']
+					);
+						// Fill the markers in the subpart
+					$sqlSafeModeUserSubpart = $this->contentObject->substituteMarkerArray(
+						$sqlSafeModeUserSubpart,
+						$sqlSafeModeUserMarkers,
+						'###|###',
+						1,
+						1
+					);
+				}
+					// Get the subpart for all modes
+				$allModesSubpart = $this->contentObject->substituteSubpart(
+					$allModesSubpart,
+					'###SQLSAFEMODEUSERSUBPART###',
+					$sqlSafeModeUserSubpart
+				);
+					// Define the markers content
+				$allModesMarkers = array(
+					'labelUsername' => 'Username:',
+					'username' => htmlspecialchars($username),
+					'labelPassword' => 'Password:',
+					'password' => htmlspecialchars(TYPO3_db_password),
+					'labelHost' => 'Host:',
+					'host' => htmlspecialchars(TYPO3_db_host),
+					'labelDatabase' => 'Database:',
+					'labelCreateDatabase' => 'Create database?'
+				);
+					// Get the subpart for the database list
+				$databasesSubpart = $this->contentObject->getSubpart($allModesSubpart, '###DATABASELIST###');
+				if ($this->config_array['mysqlConnect']) {
+						// Get the subpart when database is available
+					$databaseAvailableSubpart = $this->contentObject->getSubpart($databasesSubpart, '###DATABASEAVAILABLE###');
+						// Get the subpart for each database table
+					$databaseItemSubpart = $this->contentObject->getSubpart($databaseAvailableSubpart, '###DATABASEITEM###');
 					$dbArr = $this->getDatabaseList();
-					reset($dbArr);
 					$options='';
 					$dbIncluded=0;
-					while(list(,$dbname)=each($dbArr))	{
-						$options.='<option value="'.htmlspecialchars($dbname).'"'.($dbname==TYPO3_db?' selected="selected"':'').'>'.htmlspecialchars($dbname).'</option>';
+					foreach ($dbArr as $dbname) {
+							// Define the markers content
+						$databaseItemMarkers = array(
+							'databaseSelected' => '',
+							'databaseName' => htmlspecialchars($dbname),
+							'databaseValue' => htmlspecialchars($dbname)
+						);
+						if ($dbname == TYPO3_db) {
+							$databaseItemMarkers['databaseSelected'] = 'selected="selected"';
+						}
+							// Fill the markers in the subpart
+						$databaseItems[]  = $this->contentObject->substituteMarkerArray(
+							$databaseItemSubpart,
+							$databaseItemMarkers,
+							'###|###',
+							1,
+							0
+						);
 						if ($dbname==TYPO3_db)	$dbIncluded=1;
 					}
-					if (!$dbIncluded && TYPO3_db)	{
-						$options.='<option value="'.htmlspecialchars(TYPO3_db).'" selected="selected">'.htmlspecialchars(TYPO3_db).' (NO ACCESS!)</option>';
+					if (!$dbIncluded && TYPO3_db) {
+						$databaseItemMarkers['databaseName'] = htmlspecialchars(TYPO3_db);
+						$databaseItemMarkers['databaseSelected'] = 'selected="selected"';
+						$databaseItemMarkers['databaseValue'] = htmlspecialchars(TYPO3_db) . ' (NO ACCESS!)';
+							// Fill the markers in the subpart
+						$databaseItems[]  = $this->contentObject->substituteMarkerArray(
+							$databaseItemSubpart,
+							$databaseItemMarkers,
+							'###|###',
+							1,
+							0
+						);
 					}
-					$theCode='<select name="TYPO3_INSTALL[localconf.php][typo_db]">'.$options.'</select><br />Create database? (Enter name):<br /><input type="text" name="TYPO3_INSTALL[localconf.php][NEW_DATABASE_NAME]" value="">';
+						// Substitute the subpart for the database tables
+					$databaseAvailableSubpart = $this->contentObject->substituteSubpart(
+						$databaseAvailableSubpart,
+						'###DATABASEITEM###',
+						implode(chr(10), $databaseItems)
+					);
 				} else {
-					$theCode='<strong>'.htmlspecialchars(TYPO3_db).'</strong><br />(Can only select database if username/password/host is correctly set first)<input type="hidden" name="TYPO3_INSTALL[localconf.php][typo_db]" value="'.htmlspecialchars(TYPO3_db).'">';
+						// Get the subpart when the database is not available
+					$databaseNotAvailableSubpart = $this->contentObject->getSubpart($databasesSubpart, '###DATABASENOTAVAILABLE###');
+					$databaseNotAvailableMarkers = array(
+						'typo3Db' => htmlspecialchars(TYPO3_db),
+						'labelNoDatabase' => '
+							(Can only select database if username/password/host
+							is correctly set first)
+						'
+					);
+						// Fill the markers in the subpart
+					$databaseNotAvailableSubpart = $this->contentObject->substituteMarkerArray(
+						$databaseNotAvailableSubpart,
+						$databaseNotAvailableMarkers,
+						'###|###',
+						1,
+						0
+					);
 				}
-				$out.=$this->wrapInCells('', '<br />');
-				$out.=$this->wrapInCells('Database:', $theCode);
-				$out.=$this->wrapInCells('', '<br />');
+					// Substitute the subpart when database is available
+				$databasesSubpart = $this->contentObject->substituteSubpart(
+					$databasesSubpart,
+					'###DATABASEAVAILABLE###',
+					$databaseAvailableSubpart
+				);
+					// Substitute the subpart when database is not available
+				$databasesSubpart = $this->contentObject->substituteSubpart(
+					$databasesSubpart,
+					'###DATABASENOTAVAILABLE###',
+					$databaseNotAvailableSubpart
+				);
+					// Substitute the subpart for the databases
+				$allModesSubpart = $this->contentObject->substituteSubpart(
+					$allModesSubpart,
+					'###DATABASELIST###',
+					$databasesSubpart
+				);
+					// Fill the markers in the subpart for all modes
+				$allModesSubpart = $this->contentObject->substituteMarkerArray(
+					$allModesSubpart,
+					$allModesMarkers,
+					'###|###',
+					1,
+					1
+				);
+					// Substitute the subpart for all modes
+				$form = $this->contentObject->substituteSubpart(
+					$form,
+					'###ALLMODES###',
+					$allModesSubpart
+				);
 
-				if ($this->mode!='123')	{
-					$this->headerStyle .= chr(10) .
-						'<script type="text/javascript" src="' . t3lib_div::getIndpEnv('TYPO3_SITE_URL') . TYPO3_mainDir . 'contrib/prototype/prototype.js"></script>
-						 <script type="text/javascript" src="' . t3lib_div::getIndpEnv('TYPO3_SITE_URL') . TYPO3_mainDir . 'sysext/install/mod/install.js"></script>';
+				if ($this->mode!='123') {
+					$this->javascript[] = '<script type="text/javascript" src="' .
+						t3lib_div::getIndpEnv('TYPO3_SITE_URL') .
+						TYPO3_mainDir .
+						'contrib/prototype/prototype.js"></script>';
+					$this->javascript[] = '<script type="text/javascript" src="' .
+						t3lib_div::getIndpEnv('TYPO3_SITE_URL') .
+						TYPO3_mainDir .
+						'sysext/install/Resources/Public/Javascript/install.js"></script>';
+						// Get the subpart for the regular mode
+					$regularModeSubpart = $this->contentObject->getSubpart($form, '###REGULARMODE###');
+						// Define the markers content
+					$regularModeMarkers = array(
+						'labelSiteName' => 'Site name:',
+						'siteName' => htmlspecialchars($GLOBALS['TYPO3_CONF_VARS']['SYS']['sitename']),
+						'labelEncryptionKey' => 'Encryption key:',
+						'encryptionKey' => htmlspecialchars($GLOBALS['TYPO3_CONF_VARS']['SYS']['encryptionKey']),
+						'labelGenerateRandomKey' => 'Generate random key'
+					);
 
-
-					$out.=$this->wrapInCells('Site name:', '<input type="text" name="TYPO3_INSTALL[localconf.php][sitename]" value="'.htmlspecialchars($GLOBALS['TYPO3_CONF_VARS']['SYS']['sitename']).'">');
-					$out.=$this->wrapInCells('', '<br />');
-					$out.=$this->wrapInCells('Encryption key:', '<a name="set_encryptionKey"></a><input type="text" name="TYPO3_INSTALL[localconf.php][encryptionKey]" value="'.htmlspecialchars($GLOBALS['TYPO3_CONF_VARS']['SYS']['encryptionKey']).'"><br /><input type="button" onclick="EncryptionKey.load(this)" value="Generate random key">');
-					$out.=$this->wrapInCells('', '<br />');
-
 						// Other
 					$fA = $this->setupGeneralCalculate();
+					$regularModeMarkers['labelCurrentValueIs'] = 'current value is';
 
-					if (is_array($fA['disable_exec_function']))	{
-						$out.=$this->wrapInCells('[BE][disable_exec_function]=', $this->getFormElement($fA['disable_exec_function'], $fA['disable_exec_function'], 'TYPO3_INSTALL[localconf.php][disable_exec_function]', $GLOBALS['TYPO3_CONF_VARS']['BE']['disable_exec_function']));
+						// Disable exec function
+					if (is_array($fA['disable_exec_function'])) {
+							// Get the subpart for the disable exec function
+						$disableExecFunctionSubpart = $this->contentObject->getSubpart($regularModeSubpart, '###DISABLEEXECFUNCTIONSUBPART###');
+						$regularModeMarkers['labelDisableExecFunction'] = '[BE][disable_exec_function]=';
+						$regularModeMarkers['strongDisableExecFunction'] = (integer) current($fA['disable_exec_function']);
+						$regularModeMarkers['defaultDisableExecFunction'] = (integer) $GLOBALS['TYPO3_CONF_VARS']['BE']['disable_exec_function'];
+						$regularModeMarkers['disableExecFunction'] = (integer) current($fA['disable_exec_function']);
+							// Fill the markers in the subpart
+						$disableExecFunctionSubpart = $this->contentObject->substituteMarkerArray(
+							$disableExecFunctionSubpart,
+							$regularModeMarkers,
+							'###|###',
+							1,
+							1
+						);
 					}
-					if (is_array($fA['gdlib']))	{
-						$out.=$this->wrapInCells('[GFX][gdlib]=', $this->getFormElement($fA['gdlib'], $fA['gdlib'], 'TYPO3_INSTALL[localconf.php][gdlib]', $GLOBALS['TYPO3_CONF_VARS']['GFX']['gdlib']));
-						if (is_array($fA['gdlib_png']) && $GLOBALS['TYPO3_CONF_VARS']['GFX']['gdlib'])	{
-							$out.=$this->wrapInCells('[GFX][gdlib_png]=', $this->getFormElement($this->setLabelValueArray($fA['gdlib_png'],2), $fA['gdlib_png'], 'TYPO3_INSTALL[localconf.php][gdlib_png]', $GLOBALS['TYPO3_CONF_VARS']['GFX']['gdlib_png']));
+						// Substitute the subpart for the disable exec function
+					$regularModeSubpart = $this->contentObject->substituteSubpart(
+						$regularModeSubpart,
+						'###DISABLEEXECFUNCTIONSUBPART###',
+						$disableExecFunctionSubpart
+					);
+
+						// GDlib
+					if (is_array($fA['gdlib'])) {
+							// Get the subpart for the disable gd lib
+						$gdLibSubpart = $this->contentObject->getSubpart($regularModeSubpart, '###DISABLEGDLIB###');
+						$regularModeMarkers['labelGdLib'] = '[GFX][gdlib]=';
+						$regularModeMarkers['strongGdLib'] = (integer) current($fA['gdlib']);
+						$regularModeMarkers['defaultGdLib'] = (integer) $GLOBALS['TYPO3_CONF_VARS']['GFX']['gdlib'];
+						$regularModeMarkers['gdLib'] = (integer) current($fA['gdlib']);
+							// Fill the markers in the subpart
+						$gdLibSubpart = $this->contentObject->substituteMarkerArray(
+							$gdLibSubpart,
+							$regularModeMarkers,
+							'###|###',
+							1,
+							1
+						);
+					}
+						// Substitute the subpart for the disable gdlib
+					$regularModeSubpart = $this->contentObject->substituteSubpart(
+						$regularModeSubpart,
+						'###DISABLEGDLIB###',
+						$gdLibSubpart
+					);
+
+						// GDlib PNG
+					if (is_array($fA['gdlib_png']) && $GLOBALS['TYPO3_CONF_VARS']['GFX']['gdlib']) {
+							// Get the subpart for the gdlib png
+						$gdLibPngSubpart = $this->contentObject->getSubpart($regularModeSubpart, '###GDLIBPNGSUBPART###');
+							// Get the subpart for the dropdown options
+						$gdLibPngOptionSubpart = $this->contentObject->getSubpart($gdLibPngSubpart, '###GDLIBPNGOPTION###');
+						$gdLibPngLabels = $this->setLabelValueArray($fA['gdlib_png'], 2);
+						reset($gdLibPngLabels);
+
+						$regularModeMarkers['labelGdLibPng'] = '[GFX][gdlib_png]=';
+						$regularModeMarkers['strongGdLibPng'] = (string) current($gdLibPngLabels);
+						$regularModeMarkers['defaultGdLibPng'] = (integer) $GLOBALS['TYPO3_CONF_VARS']['GFX']['gdlib_png'];
+
+						foreach ($gdLibPngLabels as $k => $v) {
+							list($cleanV) = explode('|', $fA['gdlib_png'][$k]);
+							$gdLibPngMarker['value'] = htmlspecialchars($fA['gdlib_png'][$k]);
+							$gdLibPngMarker['data'] = htmlspecialchars($v);
+							if (!strcmp($GLOBALS['TYPO3_CONF_VARS']['GFX']['gdlib_png'], $cleanV)) {
+								$gdLibPngMarker['selected'] = 'selected="selected"';
+							}
+								// Fill the markers in the subpart
+							$gdLibPngOptions[] = $this->contentObject->substituteMarkerArray(
+								$gdLibPngOptionSubpart,
+								$gdLibPngMarker,
+								'###|###',
+								1,
+								1
+							);
 						}
+							// Substitute the subpart for the dropdown options
+						$gdLibPngSubpart = $this->contentObject->substituteSubpart(
+							$gdLibPngSubpart,
+							'###GDLIBPNGOPTION###',
+							implode(chr(10), $gdLibPngOptions)
+						);
+							// Fill the markers in the subpart
+						$gdLibPngSubpart = $this->contentObject->substituteMarkerArray(
+							$gdLibPngSubpart,
+							$regularModeMarkers,
+							'###|###',
+							1,
+							1
+						);
 					}
-					if (is_array($fA['im']))	{
-						$out.=$this->wrapInCells('[GFX][im]=', $this->getFormElement($fA['im'], $fA['im'], 'TYPO3_INSTALL[localconf.php][im]', $GLOBALS['TYPO3_CONF_VARS']['GFX']['im']));
-						$out.=$this->wrapInCells('[GFX][im_combine_filename]=', $this->getFormElement($fA['im_combine_filename'], ($fA['im_combine_filename']?$fA['im_combine_filename']:"combine"), 'TYPO3_INSTALL[localconf.php][im_combine_filename]', $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_combine_filename']));
-						$out.=$this->wrapInCells('[GFX][im_version_5]=', $this->getFormElement($fA['im_version_5'], ($fA['im_version_5']?$fA['im_version_5']:''), 'TYPO3_INSTALL[localconf.php][im_version_5]', $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_version_5']));
-						if ($GLOBALS['TYPO3_CONF_VARS']['GFX']['im'])	{
-							if (is_array($fA['im_path']))	{
-								$out.=$this->wrapInCells('[GFX][im_path]=', $this->getFormElement($this->setLabelValueArray($fA['im_path'],1), $this->setLabelValueArray($fA['im_path'],0), 'TYPO3_INSTALL[localconf.php][im_path]', $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_path']));
+						// Substitute the subpart for the gdlib png
+					$regularModeSubpart = $this->contentObject->substituteSubpart(
+						$regularModeSubpart,
+						'###GDLIBPNGSUBPART###',
+						$gdLibPngSubpart
+					);
+
+						// ImageMagick
+					if (is_array($fA['im'])) {
+							// Get the subpart for ImageMagick
+						$imageMagickSubpart = $this->contentObject->getSubpart($regularModeSubpart, '###IMAGEMAGICKSUBPART###');
+							// Define the markers content
+						$regularModeMarkers['labelImageMagick'] = '[GFX][im]=';
+						$regularModeMarkers['strongImageMagick'] = (string) current($fA['im']);
+						$regularModeMarkers['defaultImageMagick'] = (integer) $GLOBALS['TYPO3_CONF_VARS']['GFX']['im'];
+						$regularModeMarkers['imageMagick'] = (integer) current($fA['im']);
+							// Fill the markers in the subpart
+						$imageMagickSubpart = $this->contentObject->substituteMarkerArray(
+							$imageMagickSubpart,
+							$regularModeMarkers,
+							'###|###',
+							1,
+							1
+						);
+
+							// IM Combine Filename
+							// Get the subpart for ImageMagick Combine filename
+						$imCombineFileNameSubpart = $this->contentObject->getSubpart($regularModeSubpart, '###IMCOMBINEFILENAMESUBPART###');
+							// Define the markers content
+						$regularModeMarkers['labelImCombineFilename'] = '[GFX][im_combine_filename]';
+						$regularModeMarkers['strongImCombineFilename'] = (string) current($fA['im_combine_filename']);
+						$regularModeMarkers['defaultImCombineFilename'] = (string) $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_combine_filename'];
+						$regularModeMarkers['imCombineFilename'] = (string) ($fA['im_combine_filename'] ? current($fA['im_combine_filename']) : 'combine');
+							// Fill the markers in the subpart
+						$imCombineFileNameSubpart = $this->contentObject->substituteMarkerArray(
+							$imCombineFileNameSubpart,
+							$regularModeMarkers,
+							'###|###',
+							1,
+							1
+						);
+
+							// IM Version 5
+							// Get the subpart for ImageMagick Version 5
+						$imVersion5Subpart = $this->contentObject->getSubpart($regularModeSubpart, '###IMVERSION5SUBPART###');
+							// Define the markers content
+						$regularModeMarkers['labelImVersion5'] = '[GFX][im_version_5]=';
+						$regularModeMarkers['strongImVersion5'] = (string) current($fA['im_version_5']);
+						$regularModeMarkers['defaultImVersion5'] = (string) $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_version_5'];
+						$regularModeMarkers['imVersion5'] = (string) ($fA['im_version_5'] ? current($fA['im_version_5']) : '');
+							// Fill the markers in the subpart
+						$imVersion5Subpart = $this->contentObject->substituteMarkerArray(
+							$imVersion5Subpart,
+							$regularModeMarkers,
+							'###|###',
+							1,
+							1
+						);
+
+						if ($GLOBALS['TYPO3_CONF_VARS']['GFX']['im']) {
+								// IM Path
+							if (is_array($fA['im_path'])) {
+									// Get the subpart for ImageMagick path
+								$imPathSubpart = $this->contentObject->getSubpart($regularModeSubpart, '###IMPATHSUBPART###');
+
+								$labelImPath = $this->setLabelValueArray($fA['im_path'], 1);
+								reset($labelImPath);
+								$imPath = $this->setLabelValueArray($fA['im_path'], 0);
+								reset($imPath);
+									// Define the markers content
+								$regularModeMarkers['labelImPath'] = '[GFX][im_path]=';
+								$regularModeMarkers['strongImPath'] = (string) current($labelImPath);
+								$regularModeMarkers['defaultImPath'] = (string) $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_path'];
+								$regularModeMarkers['ImPath'] = (string) current($imPath);
+									// Fill the markers in the subpart
+								$imPathSubpart = $this->contentObject->substituteMarkerArray(
+									$imPathSubpart,
+									$regularModeMarkers,
+									'###|###',
+									1,
+									1
+								);
 							}
-							if (is_array($fA['im_path_lzw']))	{
-								$out.=$this->wrapInCells('[GFX][im_path_lzw]=', $this->getFormElement($this->setLabelValueArray($fA['im_path_lzw'],1), $this->setLabelValueArray($fA['im_path_lzw'],0), 'TYPO3_INSTALL[localconf.php][im_path_lzw]', $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_path_lzw']));
+								// IM Path LZW
+							if (is_array($fA['im_path_lzw'])) {
+									// Get the subpart for ImageMagick lzw path
+								$imPathLzwSubpart = $this->contentObject->getSubpart($regularModeSubpart, '###IMPATHLZWSUBPART###');
+									// Get the subpart for ImageMagick lzw path dropdown options
+								$imPathOptionSubpart = $this->contentObject->getSubpart($regularModeSubpart, '###IMPATHLZWOPTION###');
+
+								$labelImPathLzw = $this->setLabelValueArray($fA['im_path_lzw'], 1);
+								reset($labelImPathLzw);
+								$imPathLzw = $this->setLabelValueArray($fA['im_path_lzw'], 0);
+								reset($imPathLzw);
+									// Define the markers content
+								$regularModeMarkers['labelImPathLzw'] = '[GFX][im_path_lzw]=';
+								$regularModeMarkers['strongImPathLzw'] = (string) current($labelImPathLzw);
+								$regularModeMarkers['defaultImPathLzw'] = (string) $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_path_lzw'];
+								$regularModeMarkers['ImPathLzw'] = (string) current($imPathLzw);
+
+								foreach ($labelImPathLzw as $k => $v) {
+									list($cleanV) = explode('|', $fA['im_path_lzw'][$k]);
+										// Define the markers content
+									$imPathLzwMarker = array(
+										'value' => htmlspecialchars($fA['im_path_lzw'][$k]),
+										'data' => htmlspecialchars($v)
+									);
+									if (!strcmp($GLOBALS['TYPO3_CONF_VARS']['GFX']['im_path_lzw'], $cleanV)) {
+										$imPathLzwMarker['selected'] = 'selected="selected"';
+									}
+										// Fill the markers in the subpart
+									$imPathLzwOptions[] = $this->contentObject->substituteMarkerArray(
+										$imPathOptionSubpart,
+										$imPathLzwMarker,
+										'###|###',
+										1,
+										1
+									);
+								}
+									// Substitute the subpart for ImageMagick lzw path dropdown options
+								$imPathLzwSubpart = $this->contentObject->substituteSubpart(
+									$imPathLzwSubpart,
+									'###IMPATHLZWOPTION###',
+									implode(chr(10), $imPathLzwOptions)
+								);
+									// Fill the markers in the subpart
+								$imPathLzwSubpart = $this->contentObject->substituteMarkerArray(
+									$imPathLzwSubpart,
+									$regularModeMarkers,
+									'###|###',
+									1,
+									1
+								);
 							}
 						}
 					}
-					$out.=$this->wrapInCells('[GFX][TTFdpi]=', '<input type="text" name="TYPO3_INSTALL[localconf.php][TTFdpi]" value="'.htmlspecialchars($GLOBALS['TYPO3_CONF_VARS']['GFX']['TTFdpi']).'">');
+						// Substitute the subpart for ImageMagick
+					$regularModeSubpart = $this->contentObject->substituteSubpart(
+						$regularModeSubpart,
+						'###IMAGEMAGICKSUBPART###',
+						$imageMagickSubpart
+					);
+						// Substitute the subpart for ImageMagick Combine filename
+					$regularModeSubpart = $this->contentObject->substituteSubpart(
+						$regularModeSubpart,
+						'###IMCOMBINEFILENAMESUBPART###',
+						$imCombineFileNameSubpart
+					);
+						// Substitute the subpart for ImageMagick Version 5
+					$regularModeSubpart = $this->contentObject->substituteSubpart(
+						$regularModeSubpart,
+						'###IMVERSION5SUBPART###',
+						$imVersion5Subpart
+					);
+						// Substitute the subpart for ImageMagick path
+					$regularModeSubpart = $this->contentObject->substituteSubpart(
+						$regularModeSubpart,
+						'###IMPATHSUBPART###',
+						$imPathSubpart
+					);
+						// Substitute the subpart for ImageMagick lzw path
+					$regularModeSubpart = $this->contentObject->substituteSubpart(
+						$regularModeSubpart,
+						'###IMPATHLZWSUBPART###',
+						$imPathLzwSubpart
+					);
+
+						// TrueType Font dpi
+						// Get the subpart for TrueType dpi
+					$ttfDpiSubpart = $this->contentObject->getSubpart($regularModeSubpart, '###TTFDPISUBPART###');
+						// Define the markers content
+					$regularModeMarkers['labelTtfDpi'] = '[GFX][TTFdpi]=';
+					$regularModeMarkers['ttfDpi'] = htmlspecialchars($GLOBALS['TYPO3_CONF_VARS']['GFX']['TTFdpi']);
+						// Fill the markers in the subpart
+					$ttfDpiSubpart = $this->contentObject->substituteMarkerArray(
+						$ttfDpiSubpart,
+						$regularModeMarkers,
+						'###|###',
+						1,
+						1
+					);
+						// Substitute the subpart for TrueType dpi
+					$regularModeSubpart = $this->contentObject->substituteSubpart(
+						$regularModeSubpart,
+						'###TTFDPISUBPART###',
+						$ttfDpiSubpart
+					);
+						// Fill the markers in the regular mode subpart
+					$regularModeSubpart = $this->contentObject->substituteMarkerArray(
+						$regularModeSubpart,
+						$regularModeMarkers,
+						'###|###',
+						1,
+						1
+					);
 				}
 
-
-				$out.=$this->wrapInCells('', '<br /><input type="submit" value="Update localconf.php"><br />
-				<strong>NOTICE: </strong>By clicking this button, localconf.php is updated with new values for the parameters listed above!');
-				$out.='
-				</table>
-				</form>';
+				$formMarkers['labelUpdateLocalConf'] = 'Update localconf.php';
+				$formMarkers['labelNotice'] = 'NOTICE:';
+				$formMarkers['labelCommentUpdateLocalConf'] = 'By clicking this button, localconf.php is updated with new values for the parameters listed above!';
+					// Substitute the subpart for regular mode
+				$form = $this->contentObject->substituteSubpart(
+					$form,
+					'###REGULARMODE###',
+					$regularModeSubpart
+				);
+					// Fill the markers
+				$out = $this->contentObject->substituteMarkerArray(
+					$form,
+					$formMarkers,
+					'###|###',
+					1,
+					1
+				);
 			break;
 			default:
-				if (is_array($this->INSTALL['localconf.php']))		{
-					$errorMessages=array();
+				if (is_array($this->INSTALL['localconf.php'])) {
 					$lines = $this->writeToLocalconf_control();
 
 						// New database?
-#debug($this->INSTALL);
-					if (trim($this->INSTALL['localconf.php']['NEW_DATABASE_NAME']))	{
+					if (trim($this->INSTALL['localconf.php']['NEW_DATABASE_NAME'])) {
 						$newdbname=trim($this->INSTALL['localconf.php']['NEW_DATABASE_NAME']);
-						if (!preg_match('/[^[:alnum:]_-]/',$newdbname))	{
-							if ($result = $GLOBALS['TYPO3_DB']->sql_pconnect(TYPO3_db_host, TYPO3_db_username, TYPO3_db_password))	{
+						if (!preg_match('/[^[:alnum:]_-]/',$newdbname)) {
+							if ($result = $GLOBALS['TYPO3_DB']->sql_pconnect(TYPO3_db_host, TYPO3_db_username, TYPO3_db_password)) {
 								if ($GLOBALS['TYPO3_DB']->admin_query('CREATE DATABASE '.$newdbname)) {
 									$this->INSTALL['localconf.php']['typo_db'] = $newdbname;
 									$this->messages[]= "Database '".$newdbname."' created";
-								} else $this->messages[]= $errorMessages[] = "Could not create database '".$newdbname."' (...not created)";
-							} else $this->messages[]= $errorMessages[] = "Could not connect to database when creating database '".$newdbname."' (...not created)";
-						} else $this->messages[]= $errorMessages[] = "The NEW database name '".$newdbname."' was not alphanumeric, a-zA-Z0-9_- (...not created)";
+								} else {
+									$this->errorMessages[] = '
+										Could not create database \'' .
+										$newdbname . '\' (...not created)
+									';
+								}
+							} else {
+								$this->errorMessages[] = '
+									Could not connect to database when creating
+									database \'' . $newdbname . '\' (...not
+									created)
+								';
+							}
+						} else {
+							$this->errorMessages[] = '
+								The NEW database name \'' . $newdbname . '\' was
+								not alphanumeric, a-zA-Z0-9_- (...not created)
+							';
+						}
 					}
-#debug($this->messages)		;
 						// Parsing values
-					reset($this->INSTALL['localconf.php']);
-					while(list($key,$value)=each($this->INSTALL['localconf.php']))		{
-						switch((string)$key)	{
+					foreach ($this->INSTALL['localconf.php'] as $key => $value) {
+						switch((string)$key) {
 							case 'typo_db_username':
-								if (strlen($value)<50)	{
+								if (strlen($value)<50) {
 									if (strcmp(TYPO3_db_username,$value))		$this->setValueInLocalconfFile($lines, '$typo_db_username', trim($value));
-								} else $this->messages[]= $errorMessages[] = "Username '".$value."' was longer than 50 chars (...not saved)";
+								} else {
+									$this->errorMessages[] = '
+										Username \'' . $value . '\' was longer
+										than 50 chars (...not saved)
+									';
+								}
 							break;
 							case 'typo_db_password':
-								if (strlen($value)<50)	{
+								if (strlen($value)<50) {
 									if (strcmp(TYPO3_db_password,$value))		$this->setValueInLocalconfFile($lines, '$typo_db_password',  trim($value));
-								} else $this->messages[]= $errorMessages[] = "Password was longer than 50 chars (...not saved)";
+								} else {
+									$this->errorMessages[] = '
+										Password was longer than 50 chars (...not saved)
+									';
+								}
 							break;
 							case 'typo_db_host':
-								if (preg_match('/^[a-zA-Z0-9_\.-]+(:.+)?$/',$value) && strlen($value)<50)	{
+								if (preg_match('/^[a-zA-Z0-9_\.-]+(:.+)?$/',$value) && strlen($value)<50) {
 									if (strcmp(TYPO3_db_host,$value))		$this->setValueInLocalconfFile($lines, '$typo_db_host', $value);
-								} else $this->messages[]= $errorMessages[] = "Host '".$value."' was not alphanumeric (a-z, A-Z, 0-9 or _-.), or longer than 50 chars (...not saved)";
+								} else {
+									$this->errorMessages[] = '
+										Host \'' . $value . '\' was not
+										alphanumeric (a-z, A-Z, 0-9 or _-.), or
+										longer than 50 chars (...not saved)
+									';
+								}
 							break;
 							case 'typo_db':
-								if (strlen($value)<50)	{
+								if (strlen($value)<50) {
 									if (strcmp(TYPO3_db,$value))		$this->setValueInLocalconfFile($lines, '$typo_db',  trim($value));
-								} else $this->messages[]= $errorMessages[] = "Database name '".$value."' was longer than 50 chars (...not saved)";
+								} else {
+									$this->errorMessages[] = '
+										Database name \'' . $value . '\' was
+										longer than 50 chars (...not saved)
+									';
+								}
 							break;
 							case 'disable_exec_function':
 								if (strcmp($GLOBALS['TYPO3_CONF_VARS']['BE']['disable_exec_function'],$value))	$this->setValueInLocalconfFile($lines, '$TYPO3_CONF_VARS[\'BE\'][\'disable_exec_function\']', $value?1:0);
